//
//  InAppSdk.h
//  InAppSdk
//
//  Created by Compte Atos on 07/06/2016.
//  Copyright © 2016 Atos Worldline. All rights reserved.
//


#import <UIKit/UIKit.h>
#import <InAppSdk/INAPPPaymentProviderResponse.h>
#import <InAppSdk/NSData+NSData_Conversion.h>
#import <InAppSdk/NSData+Base64.h>
#import <InAppSdk/INAPPPaymentResponse.h>
#import <InAppSdk/INAPPGetWalletDataResponse.h>
#import <InAppSdk/INAPPAddCardResponse.h>
#import <InAppSdk/INAPPDeletePaymentMeanResponse.h>
#import <InAppSdk/INAPPHmac.h>
#import <InAppSdk/INAPPGetTransactionDataResponse.h>
#import <InAppSdk/INAPPS10TransactionReference.h>
#import <InAppSdk/INAPPOrderResponse.h>
#import <InAppSdk/INAPPGetWalletDataResponseItem.h>
#import <InAppSdk/INAPPCardCheckEnrollmentResponse.h>
#import <InAppSdk/INAPPWalletCheckEnrollmentResponse.h>
#import <InAppSdk/INAPPS10TransactionReference.h>
#import <InAppSdk/INAPPCardData.h>
#import <InAppSdk/INAPPGetCardDataResponse.h>
#import <InAppSdk/InAppSdk.h>
#import <InAppSdk/INAPPPaymentTokenResponse.h>

//! Project version number for InAppSdk.
FOUNDATION_EXPORT double InAppSdkVersionNumber;

//! Project version string for InAppSdk.
FOUNDATION_EXPORT const unsigned char InAppSdkVersionString[];

// In this header, you should import all the public headers of your framework using statements like #import <InAppSdk/PublicHeader.h>



@interface InAppSdk : NSObject


+ (void) cardOrderWithCardNumber:(NSString *) cardNumber
                 andCardCSCValue:(NSString *) cardCSCValue
               andCardExpiryDate:(NSString *) cardExpiryDate
               andPublicKeyValue:(NSString *) publicKeyValue
              andRedirectionData:(NSString *) redirectionData
               andRedirectionUrl:(NSString *) redirectionUrl
           andRedirectionVersion:(NSString *) redirectionVersion
                      andHandler:(void (^)(INAPPOrderResponse * response)) handler;


+ (void) cardOrderWithCardNumber:(NSString *) cardNumber
                 andCardCSCValue:(NSString *) cardCSCValue
               andCardExpiryDate:(NSString *) cardExpiryDate
             andPaymentMeanBrand:(NSString *) paymentMeanBrand
andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
               andPublicKeyValue:(NSString *) publicKeyValue
              andRedirectionData:(NSString *) redirectionData
               andRedirectionUrl:(NSString *) redirectionUrl
           andRedirectionVersion:(NSString *) redirectionVersion
                      andHandler:(void (^)(INAPPOrderResponse * response)) handler;



+ (void) addCardWithCardNumber:(NSString *) cardNumber
           andPaymentMeanAlias:(NSString *) paymentMeanAlias
             andCardExpiryDate:(NSString *) cardExpiryDate
             andPublicKeyValue:(NSString *) publicKeyValue
            andRedirectionData:(NSString *) redirectionData
             andRedirectionUrl:(NSString *) redirectionUrl
         andRedirectionVersion:(NSString *) redirectionVersion
                    andHandler:(void (^)(INAPPAddCardResponse * response)) handler;

+ (void) addCardWithCardNumber:(NSString *) cardNumber
           andPaymentMeanAlias:(NSString *) paymentMeanAlias
             andCardExpiryDate:(NSString *) cardExpiryDate
           andPaymentMeanBrand:(NSString *) paymentMeanBrand
             andPublicKeyValue:(NSString *) publicKeyValue
            andRedirectionData:(NSString *) redirectionData
             andRedirectionUrl:(NSString *) redirectionUrl
         andRedirectionVersion:(NSString *) redirectionVersion
                    andHandler:(void (^)(INAPPAddCardResponse * response)) handler;

+ (void) addCardWithCardNumber:(NSString *) cardNumber
           andPaymentMeanAlias:(NSString *) paymentMeanAlias
             andCardExpiryDate:(NSString *) cardExpiryDate
           andPaymentMeanBrand:(NSString *) paymentMeanBrand
andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
             andPublicKeyValue:(NSString *) publicKeyValue
            andRedirectionData:(NSString *) redirectionData
             andRedirectionUrl:(NSString *) redirectionUrl
         andRedirectionVersion:(NSString *) redirectionVersion
                    andHandler:(void (^)(INAPPAddCardResponse * response)) handler;

+ (void) deletePaymentMeanWithPaymentMeanId:(NSInteger) paymentMeanId
             andPublicKeyValue:(NSString * ) publicKeyValue
            andRedirectionData:(NSString *) redirectionData
             andRedirectionUrl:(NSString *) redirectionUrl
         andRedirectionVersion:(NSString *) redirectionVersion
                    andHandler:(void (^)(INAPPDeletePaymentMeanResponse * response)) handler;

+ (void) getWalletDataWithPublicKeyValue:(NSString * ) publicKeyValue
                      andRedirectionData:(NSString *) redirectionData
                       andRedirectionUrl:(NSString *) redirectionUrl
                   andRedirectionVersion:(NSString *) redirectionVersion
                              andHandler:(void (^)(INAPPGetWalletDataResponse * response)) handler;

+ (void) walletOrderWithPaymentMeanId:(NSInteger) paymentMeanId
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPOrderResponse * response)) handler;

+ (void) walletOrderWithPaymentMeanId:(NSInteger) paymentMeanId
                          andCscValue:(NSString *) cscValue
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPOrderResponse * response)) handler;

+ (void) walletOrderWithPaymentMeanId:(NSInteger) paymentMeanId
                  andPaymentMeanBrand:(NSString *) paymentMeanBrand
   andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
                          andCscValue:(NSString *) cscValue
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPOrderResponse * response)) handler;

+ (void) walletCheckEnrollmentWithPaymentMeanId:(NSInteger) paymentMeanId
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPWalletCheckEnrollmentResponse * response)) handler;

+ (void) walletCheckEnrollmentWithPaymentMeanId:(NSInteger) paymentMeanId
                          andCscValue:(NSString *) cscValue
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPWalletCheckEnrollmentResponse * response)) handler;

+ (void) walletCheckEnrollmentWithPaymentMeanId:(NSInteger) paymentMeanId
                            andPaymentMeanBrand:(NSString *) paymentMeanBrand
             andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
                          andCscValue:(NSString *) cscValue
                    andPublicKeyValue:(NSString * ) publicKeyValue
                   andRedirectionData:(NSString *) redirectionData
                    andRedirectionUrl:(NSString *) redirectionUrl
                andRedirectionVersion:(NSString *) redirectionVersion
                           andHandler:(void (^)(INAPPWalletCheckEnrollmentResponse * response)) handler;

+ (void) paymentProviderOrderWithPublicKeyValue:(NSString * ) publicKeyValue
                             andRedirectionData:(NSString *) redirectionData
                              andRedirectionUrl:(NSString *) redirectionUrl
                          andRedirectionVersion:(NSString *) redirectionVersion
                                     andHandler:(void (^)(INAPPPaymentProviderResponse * response)) handler;

+ (void) getTransactionDataWithRedirectionUrl:(NSString *) redirectionUrl
                    andTransactionContextData:(NSString *) transactionContextData
                 andTransactionContextVersion:(NSString *) transactionContextVersion
                                   andHandler:(void (^)(INAPPGetTransactionDataResponse * response)) handler;

+ (void) cardCheckEnrollmentWithCardNumber:(NSString *) cardNumber
                           andCardCSCValue:(NSString *) cardCSCValue
                         andCardExpiryDate:(NSString *) cardExpiryDate
                         andPublicKeyValue:(NSString *) publicKeyValue
                        andRedirectionData:(NSString *) redirectionData
                         andRedirectionUrl:(NSString *) redirectionUrl
                     andRedirectionVersion:(NSString *) redirectionVersion
                                andHandler:(void (^)(INAPPCardCheckEnrollmentResponse * response)) handler;

+ (void) cardCheckEnrollmentWithCardNumber:(NSString *) cardNumber
                           andCardCSCValue:(NSString *) cardCSCValue
                         andCardExpiryDate:(NSString *) cardExpiryDate
                       andPaymentMeanBrand:(NSString *) paymentMeanBrand
        andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
                         andPublicKeyValue:(NSString *) publicKeyValue
                        andRedirectionData:(NSString *) redirectionData
                         andRedirectionUrl:(NSString *) redirectionUrl
                     andRedirectionVersion:(NSString *) redirectionVersion
                                andHandler:(void (^)(INAPPCardCheckEnrollmentResponse * response)) handler;



+ (void) cardValidateAuthenticationAndOrderWithPaResMessage:(NSString *) paResMessage
                                  andTransactionContextData:(NSString *) transactionContextData
                                          andRedirectionUrl:(NSString *) redirectionUrl
                               andTransactionContextVersion:(NSString *) transactionContextVersion
                                                 andHandler:(void (^)(INAPPOrderResponse * response)) handler;


+ (void) getCardDataWithCardNumber:(NSString *) cardNumber
                        andCardIIN:(NSString *) cardIIN
                 andPublicKeyValue:(NSString *) publicKeyValue
                andRedirectionData:(NSString *) redirectionData
                 andRedirectionUrl:(NSString *) redirectionUrl
             andRedirectionVersion:(NSString *) redirectionVersion
                        andHandler:(void (^)(INAPPGetCardDataResponse * response)) handler;


+ (void) generatePaymentTokenWithCardNumber:(NSString *) cardNumber
                            andCardCSCValue:(NSString *) cardCSCValue
                          andCardExpiryDate:(NSString *) cardExpiryDate
                        andPaymentMeanBrand:(NSString *) paymentMeanBrand
         andPaymentMeanBrandSelectionStatus:(NSString *) paymentMeanBrandSelectionStatus
                          andPublicKeyValue:(NSString *) publicKeyValue
                          andRedirectionUrl:(NSString *) redirectionUrl
                      andRedirectionVersion:(NSString *) redirectionVersion
                              andMerchantId:(NSString *) merchantId
                                 andHandler:(void (^)(INAPPPaymentTokenResponse * response)) handler;


+ (NSDictionary * ) getPhoneContext;

@end

